Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java	(revision 1300)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRule.java	(revision 1301)
@@ -60,8 +60,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param statistics
-     * @param results
+     *
      */
     private void analyzeStatistics(TextInputStatistics       statistics,
@@ -74,8 +71,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param statistics
-     * @param results
+     *
      */
     private void checkTextInputRatio(TextInputStatistics       statistics,
@@ -112,8 +106,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param statistics
-     * @param results
+     *
      */
     private void checkTextFieldEntryRepetitions(TextInputStatistics       statistics,
@@ -173,8 +164,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param statistics
-     * @param results
+     *
      */
     private void checkTextFieldNoLetterOrDigitInputs(TextInputStatistics       statistics,
@@ -232,8 +220,5 @@
 
     /**
-     * TODO: comment
      * 
-     * @param taskTree
-     * @param statistics
      */
     private void calculateStatistics(Collection<ITask> tasks, TextInputStatistics statistics) {
@@ -244,8 +229,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param taskTree
-     * @param statistics
+     *
      */
     private void calculateStatistics(ITask task, TextInputStatistics statistics) {
@@ -271,10 +253,5 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @param task
-     * @return
+     *
      */
     private boolean isTextInput(ITask task) {
@@ -290,8 +267,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param taskTree
-     * @param statistics
+     *
      */
     private void calculateStatistics(IEventTask node, TextInputStatistics statistics) {
@@ -316,8 +290,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param enteredText
-     * @return
+     *
      */
     private String[] determineTextFragments(String enteredText) {
@@ -350,9 +321,5 @@
 
     /**
-     * TODO: comment
-     * 
-     * @param lastChar
-     * @param currentChar
-     * @return
+     *
      */
     private boolean isEqualCharacterType(char char1, char char2) {
@@ -383,9 +350,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @param node
-         * @param fragments
-         * 
+         *
          */
         public void addTextFieldInput(IEventTask node, String[] fragments) {
@@ -394,9 +357,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @param node
-         * @param fragments
-         * 
+         *
          */
         public void addTextAreaInput(IEventTask node, String[] fragments) {
@@ -405,7 +364,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @return
+         *
          */
         public int getNoOfAllEvents() {
@@ -414,7 +371,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @return
+         *
          */
         public int getNoOfTextFieldInputs() {
@@ -423,8 +378,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @param i
-         * @return
+         *
          */
         public String[] getTextFieldInputFragments(int index) {
@@ -433,7 +385,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @return
+         *
          */
         public int getNoOfTextAreaInputs() {
@@ -442,8 +392,5 @@
 
         /**
-         * TODO: comment
-         * 
-         * @param i
-         * @return
+         *
          */
         public String[] getTextAreaInputFragments(int index) {
@@ -452,6 +399,5 @@
 
         /**
-         * TODO: comment
-         * 
+         *
          */
         public void incrementNoOfOtherEventTasks() {