Index: trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDbinaryAligment.java
===================================================================
--- trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDbinaryAligment.java	(revision 1303)
+++ trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDbinaryAligment.java	(revision 1303)
@@ -0,0 +1,74 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.plugin.alignment.commands;
+
+import java.io.File;
+import java.io.FilenameFilter;
+import java.util.Collection;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.logging.Level;
+
+import de.ugoe.cs.autoquest.CommandHelpers;
+import de.ugoe.cs.autoquest.eventcore.Event;
+import de.ugoe.cs.util.console.Command;
+import de.ugoe.cs.util.console.Console;
+import de.ugoe.cs.util.console.GlobalDataContainer;
+
+/**
+ * <p>
+ * Command to generate a binary alignment of two sequences
+ * </p>
+ * 
+ * @author Steffen Herbold
+ * @version 1.0
+ */
+public class CMDbinaryAligment implements Command {
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see de.ugoe.cs.util.console.Command#run(java.util.List)
+	 */
+	@Override
+	public void run(List<Object> parameters) {
+		String sequencesName;
+		String algorithm;
+		try {
+			sequencesName = (String) parameters.get(0);
+			if (parameters.size() > 1) {
+				algorithm = (String) parameters.get(1);
+			}
+		} catch (Exception e) {
+			throw new IllegalArgumentException();
+		}
+
+		
+		Collection<List<Event>> sequences = new LinkedList<List<Event>>();
+		
+
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see de.ugoe.cs.util.console.Command#help()
+	 */
+	@Override
+	public String help() {
+		return "binaryAlignment <sequencesName> {<algorithm>}";
+	}
+
+}
Index: trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDefgTestCasesToSequences.java
===================================================================
--- trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/guitar/commands/CMDefgTestCasesToSequences.java	(revision 927)
+++ 	(revision )
@@ -1,97 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.plugin.guitar.commands;
-
-import java.io.File;
-import java.io.FilenameFilter;
-import java.util.Collection;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.logging.Level;
-
-import de.ugoe.cs.autoquest.CommandHelpers;
-import de.ugoe.cs.autoquest.eventcore.Event;
-import de.ugoe.cs.autoquest.plugin.guitar.GUITARTestCaseParser;
-import de.ugoe.cs.util.console.Command;
-import de.ugoe.cs.util.console.Console;
-import de.ugoe.cs.util.console.GlobalDataContainer;
-
-/**
- * <p>
- * Command to load a set of sequences from a set of GUITAR test cases.
- * </p>
- * 
- * @author Steffen Herbold
- * @version 1.0
- */
-public class CMDefgTestCasesToSequences implements Command {
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#run(java.util.List)
-	 */
-	@Override
-	public void run(List<Object> parameters) {
-		String foldername;
-		String sequencesName;
-		String efgFileName = null;
-		try {
-			foldername = (String) parameters.get(0);
-			sequencesName = (String) parameters.get(1);
-			if (parameters.size() >= 3) {
-				efgFileName = (String) parameters.get(2);
-			}
-		} catch (Exception e) {
-			throw new IllegalArgumentException();
-		}
-
-		File folder = new File(foldername);
-		
-		File[] testcaseFiles = folder.listFiles( new FilenameFilter() {
-			@Override
-			public boolean accept(File dir, String name) {
-				return name.endsWith(".tst");
-			}
-		});
-		Collection<List<Event>> sequences = new LinkedList<List<Event>>();
-		GUITARTestCaseParser parser;
-		if (efgFileName == null) {
-			parser = new GUITARTestCaseParser();
-		} else {
-			parser = new GUITARTestCaseParser(efgFileName);
-		}
-		for (File testcaseFile : testcaseFiles) {
-			Console.traceln(Level.INFO, "Loading from file "
-					+ testcaseFile.getAbsolutePath());
-			sequences.add(parser.parseTestCaseFile(testcaseFile));
-		}
-		if (GlobalDataContainer.getInstance().addData(sequencesName, sequences)) {
-			CommandHelpers.dataOverwritten(sequencesName);
-		}
-
-	}
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#help()
-	 */
-	@Override
-	public String help() {
-		return "efgTestCasesToSequences <directory> <sequencesName> {<guiFileName>}";
-	}
-
-}
Index: trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDefgToDFA.java
===================================================================
--- trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/guitar/commands/CMDefgToDFA.java	(revision 927)
+++ 	(revision )
@@ -1,67 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.plugin.guitar.commands;
-
-import java.util.List;
-
-import de.ugoe.cs.autoquest.plugin.guitar.EFGModelGenerator;
-import de.ugoe.cs.autoquest.usageprofiles.DeterministicFiniteAutomaton;
-import de.ugoe.cs.util.console.Command;
-import de.ugoe.cs.util.console.GlobalDataContainer;
-
-/**
- * <p>
- * Command to that loads an EFG and creates Deterministic Finite Automaton (DFA)
- * with the same structure.
- * </p>
- * 
- * @author Steffen Herbold
- * @version 1.0
- */
-public class CMDefgToDFA implements Command {
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#run(java.util.List)
-	 */
-	@Override
-	public void run(List<Object> parameters) {
-		String filename;
-		String modelname;
-		try {
-			filename = (String) parameters.get(0);
-			modelname = (String) parameters.get(1);
-		} catch (Exception e) {
-			throw new IllegalArgumentException();
-		}
-
-		EFGModelGenerator modelGenerator = new EFGModelGenerator();
-		DeterministicFiniteAutomaton model = modelGenerator
-				.efgToDeterministicFiniteAutomaton(filename);
-		GlobalDataContainer.getInstance().addData(modelname, model);
-	}
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#help()
-	 */
-	@Override
-	public String help() {
-		return "efgToDFA <filename> <modelname>";
-	}
-
-}
Index: trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/commands/CMDefgToMM.java
===================================================================
--- trunk/autoquest-plugin-guitar/src/main/java/de/ugoe/cs/autoquest/plugin/guitar/commands/CMDefgToMM.java	(revision 927)
+++ 	(revision )
@@ -1,67 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.plugin.guitar.commands;
-
-import java.util.List;
-
-import de.ugoe.cs.autoquest.plugin.guitar.EFGModelGenerator;
-import de.ugoe.cs.autoquest.usageprofiles.FirstOrderMarkovModel;
-import de.ugoe.cs.util.console.Command;
-import de.ugoe.cs.util.console.GlobalDataContainer;
-
-/**
- * <p>
- * Command to that loads an EFG and creates a first-order Markov model with the
- * same structure.
- * </p>
- * 
- * @author Steffen Herbold
- * @version 1.0
- */
-public class CMDefgToMM implements Command {
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#run(java.util.List)
-	 */
-	@Override
-	public void run(List<Object> parameters) {
-		String filename;
-		String modelname;
-		try {
-			filename = (String) parameters.get(0);
-			modelname = (String) parameters.get(1);
-		} catch (Exception e) {
-			throw new IllegalArgumentException();
-		}
-
-		EFGModelGenerator modelGenerator = new EFGModelGenerator();
-		FirstOrderMarkovModel model = modelGenerator
-				.efgToFirstOrderMarkovModel(filename);
-		GlobalDataContainer.getInstance().addData(modelname, model);
-	}
-
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see de.ugoe.cs.util.console.Command#help()
-	 */
-	@Override
-	public String help() {
-		return "efgToMM <filename> <modelname>";
-	}
-
-}