Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsEventTest.java	(revision 1326)
@@ -22,7 +22,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/contains/ContainsPatternTest.java	(revision 1326)
@@ -22,7 +22,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithEventTest.java	(revision 1326)
@@ -21,7 +21,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/endswith/EndsWithPatternTest.java	(revision 1326)
@@ -24,7 +24,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventAndContainsEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventAndContainsEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventAndContainsEventTest.java	(revision 1326)
@@ -22,7 +22,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternAndContainsPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternAndContainsPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternAndContainsPatternTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsAndEndsWithPatternTest.java	(revision 1326)
@@ -24,7 +24,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsEventTest.java	(revision 1326)
@@ -22,7 +22,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndContainsPatternTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndEndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventAndEndsWithPatternTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsEventEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsEventEndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsEventEndsWithPatternTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventContainsPatternAndEndsWithPatternTest.java	(revision 1326)
@@ -24,7 +24,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithEventTest.java	(revision 1326)
@@ -21,7 +21,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndContainsPatternTest.java	(revision 1326)
@@ -24,7 +24,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java	(revision 1326)
@@ -24,7 +24,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsPatternAndEndsWithEventTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsPatternAndEndsWithEventTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsPatternAndEndsWithEventTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
Index: trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternTest.java	(revision 1319)
+++ trunk/autoquest-plugin-usability2-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternTest.java	(revision 1326)
@@ -23,7 +23,7 @@
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 