Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/HTMLLogParser.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/HTMLLogParser.java	(revision 1379)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/HTMLLogParser.java	(revision 1416)
@@ -45,5 +45,9 @@
  * <p>
  * This class provides the functionality to parse XML log files generated by the HTMLMonitor of
- * AutoQUEST. The result of parsing a file is a collection of event sequences and a GUI model
+ * AutoQUEST. The result of parsing a file is a collection of event sequences and a GUI model.
+ * </p>
+ * <p>
+ * The parser can be configured with parsing parameters to ignore, e.g., ids or indexes of
+ * parsed GUI elements. Details can be found in the manual pages of the respective parsing commands.
  * </p>
  * 
@@ -86,8 +90,8 @@
     /**
      * <p>
-     * TODO: comment
+     * initializes the parser with the parsing parameters to be considered
      * </p>
      *
-     * @param parseParams
+     * @param parseParams the parsing parameters to be considered
      */
     public HTMLLogParser(Map<String, List<String>> parseParams) {
@@ -220,10 +224,14 @@
     /**
      * <p>
-     * TODO: comment
+     * checks if for a specific GUI element the index shall be ignored or not by considering the
+     * parsing parameters.
      * </p>
      *
-     * @param tagName
-     * @param parent
-     * @return
+     * @param tagName the tag of the considered GUI element
+     * @param index   the index of the GUI element
+     * @param id      the id of the GUI element
+     * @param parent  the parent GUI element of the considered GUI element
+     * 
+     * @return true if the index shall be ignored, false else.
      */
     private boolean clearIndex(String tagName, int index, String id, HTMLGUIElement parent) {
@@ -233,12 +241,14 @@
     /**
      * <p>
-     * TODO: comment
+     * checks if the parsing parameters define a replacement for the id of the given GUI element
+     * and if so returns this replacement
      * </p>
      *
-     * @param tagName
-     * @param index
-     * @param htmlId
-     * @param parent
-     * @return
+     * @param tagName the tag of the considered GUI element
+     * @param index   the index of the GUI element
+     * @param id      the id of the GUI element
+     * @param parent  the parent GUI element of the considered GUI element
+     * 
+     * @return the identified replacement
      */
     private String replaceHTMLId(String tagName, int index, String htmlId, HTMLGUIElement parent)
@@ -301,10 +311,14 @@
     /**
      * <p>
-     * TODO: comment
+     * checks if for a specific GUI element the id shall be ignored or not by considering the
+     * parsing parameters.
      * </p>
      *
-     * @param tagName
-     * @param parent
-     * @return
+     * @param tagName the tag of the considered GUI element
+     * @param index   the index of the GUI element
+     * @param id      the id of the GUI element
+     * @param parent  the parent GUI element of the considered GUI element
+     * 
+     * @return true if the id shall be ignored, false else.
      */
     private boolean clearHTMLId(String tagName, int index, String id, HTMLGUIElement parent) {
@@ -314,10 +328,15 @@
     /**
      * <p>
-     * TODO: comment
+     * convenience method to check for the existence for specific parsing parameters for clearing
+     * ids or indexes of GUI elements.
      * </p>
      *
-     * @param tagName
-     * @param parent
-     * @return
+     * @param parseParamId the id of the parsing parameter to be checked for the GUI element
+     * @param tagName      the tag of the considered GUI element
+     * @param index        the index of the GUI element
+     * @param id           the id of the GUI element
+     * @param parent       the parent GUI element of the considered GUI element
+     * 
+     * @return true if the denoted parse parameter is set to ignore, false else.
      */
     private boolean clearSomething(String         parseParamId,
@@ -350,11 +369,15 @@
     /**
      * <p>
-     * TODO: comment
+     * convenience method to check if a given GUI element matches a specification tags provided
+     * through the parsing parameters.
      * </p>
      *
-     * @param tagName
-     * @param parent
-     * @param spec
-     * @return
+     * @param tagName  the tag of the considered GUI element
+     * @param index    the index of the GUI element
+     * @param id       the id of the GUI element
+     * @param parent   the parent GUI element of the considered GUI element
+     * @param tagSpecs the specification of a GUI element to match against the given GUI element
+     * 
+     * @return true if the denoted parse parameter is set to ignore, false else.
      */
     private boolean tagMatchesTagSpec(String         tagName,